import * as tslib_1 from "tslib";
import Register from "@vericus/slate-kit-utils-register-helpers";
import Options from "./options";
import createProps from "./props";
import createCommands from "./commands";
import createQueries from "./queries";
export default function createPlugin(pluginOptions) {
    if (pluginOptions === void 0) { pluginOptions = {}; }
    var options = Options.create(pluginOptions);
    var marks = options.marks, renderer = options.renderer;
    var commands = createCommands(options);
    var queries = createQueries(options);
    var props = createProps(options);
    var plugins = [
        Register({
            options: options,
            marks: marks,
            props: props
        }),
        {
            commands: commands,
            queries: queries
        }
    ];
    if (renderer) {
        var rendererPlugins = renderer(options);
        if (Array.isArray(rendererPlugins)) {
            plugins = tslib_1.__spread(plugins, rendererPlugins);
        }
        else {
            plugins = tslib_1.__spread(plugins, [rendererPlugins]);
        }
    }
    return plugins;
}
//# sourceMappingURL=index.js.map